
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GUILLERMO CARLOMAGNO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Y_sa, useY_sa, Yfin, PONDImplD1, PONDImplD12, Wmat, useFE] = IMPORT_DATA_sp(useYearF,useMonth0, useMonthF, FolderData )

PARAMETERS_and_DATA_sp

routeSubClases = [FolderData,'subClases.xlsx'];

sheet = 'Empalme';
nameFile_sa = 'empalmadasOficial_sa';
    
[~ , FEall] = SeasonalDummies([], 12, Year0Base, useYearF);
FEall = FEall(m0Base:end, :);
idx0 = find(FEall(:,1)==useYear0.*FEall(:,2)==useMonth0);
useFE = FEall(idx0:end,:);
idx1 = find(double(useFE(:,1)==useYearF).*double(useFE(:,2)==useMonthF));
useFE = useFE(1:idx1,:);

%-------------------
%Idx for emplame oficial
idxFe{1} = double(useFE(:,1)<=2008);                                                                                                                                
idxFe{2} = double(useFE(:,1)==2009) - double(useFE(:,2)==12).*double(useFE(:,1)==2009);                                                     
idxFe{3} = double(useFE(:,1)<=2013).* double(useFE(:,1)>2009) + double(useFE(:,2)==12).*double(useFE(:,1)==2009) -  double(useFE(:,2)==12).*double(useFE(:,1)==2013);    
idxFe{4} = double(useFE(:,1)<=2018).* double(useFE(:,1)>2013) + double(useFE(:,2)==12).*double(useFE(:,1)==2013);     
idxFe{5} = double(useFE(:,1)>2018);    
%-------------------
check = [useFE,idxFe{1}, idxFe{2}, idxFe{3}, idxFe{4} idxFe{5}];         

[Y,names] = xlsread(routeSubClases ,sheet);
Y = Y(:,1:Nbase+2);
names = names(1,2:Nbase+1);
Y = Y(idx0:end,:);
Y=Y(1:idx1,:);
agg = Y(:,Nbase+2);
Y=Y(:,1:Nbase);
qNan = sum(isnan(Y));

W.b18 = xlsread(routeSubClases, 'W_2018', 'B1:EO1')/100;
W.b13 = xlsread(routeSubClases, 'W_2013', 'B1:EO1')/100;
W.b09 = xlsread(routeSubClases, 'W_2009', 'B1:EO1')/100;
W.b08 = xlsread(routeSubClases, 'W_2008', 'B1:EO1')/100;
W.b98 = xlsread(routeSubClases, 'W_1998', 'B1:EO1')/100;

Wcell{5} = W.b18; Wcell{4} = W.b13; Wcell{3} = W.b09; Wcell{2} = W.b08;
Wcell{1} = W.b98;

[~, ~ , subcRaw] =  xlsread(routeSubClases, 'base2018', 'B3:EO499');
subcOrig{5}=cell2mat(subcRaw);    

[~, ~ , subcRaw] =  xlsread(routeSubClases, 'base2013', 'B3:EO499');
subcOrig{4}=cell2mat(subcRaw);
[~, ~ , subcRaw] =  xlsread(routeSubClases, 'base2009', 'B3:EO499');
subcOrig{3}=cell2mat(subcRaw);
[~, ~ , subcRaw] =  xlsread(routeSubClases, 'base2008', 'B3:EO499');
subcOrig{2}=cell2mat(subcRaw);
[~, ~ , subcRaw] =  xlsread(routeSubClases, 'base1998', 'B3:EO499');
subcOrig{1}=cell2mat(subcRaw);

[T,N] = size(Y);
Wmat = nan(T,N);
for i=1:5        
    subClas = subcOrig{i};
    [t,N] = size(subClas);
    if i==1
        ipcsOrig=nan(t,5);
    end
    w = Wcell{i}; 
    w(isnan(w)) = 0; w = w/sum(w);
    repW = repmat(w, t,1);
    ipc = subClas*w';
    repIPC = repmat(ipc,1,N);
    rel1 = (lagmatrix(subClas,1)./lagmatrix(repIPC,1));
    rel12{i} = (lagmatrix(subClas,12)./lagmatrix(repIPC,12));
    
    if i>1
       rel12{i}(isnan(rel12{i})) =  rel12{i-1}(isnan(rel12{i}));
       rel12{i}(rel12{i}==0) =  rel12{i-1}(rel12{i}==0);
    end
        
    ponImpl_D1 =  rel1.*repW;
    ponImpl_D12 =  rel12{i}.*repW;
    implPondD1 = ponImpl_D1(idx0:end, :);
    implPondD12 = ponImpl_D12(idx0:end, :);
    ipcsOrig(1:t,i) = ipc;
    
    Wmat(idxFe{i}==1, :) = repmat(Wcell{i}, sum(idxFe{i}), 1);
    PONDImplD1(idxFe{i}==1, :) = implPondD1(idxFe{i}==1, :);
    PONDImplD12(idxFe{i}==1, :) = implPondD12(idxFe{i}==1, :); 
end
Wmat(isnan(Wmat)) = 0;
Wmat = Wmat(1:T, :); 
Wmat = Wmat./repmat(sum(Wmat,2), 1, size(Wmat,2));

Yfin = Y;
Y_sa = xlsread([FolderData, nameFile_sa]);

useY_sa = Y_sa;
qDiff_SA = (useYear0-Year0BaseSA)*12-(m0BaseSA-useMonth0);
useY_sa = useY_sa(qDiff_SA+1:end,:); 
 

end %function
