%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GUILLERMO CARLOMAGNO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [SeasDUM, FE] = SeasonalDummies(T, Frequency, varargin)

% Argumentos opcionales:
% Y1 and YF, si se ponen ambos, T se puede dejar vaco.

%-------------------------------------------
if nargin==2
    Y1 = 1990;
    YF = Y1 -1 + ceil(T/Frequency);
elseif nargin == 3
    Y1 = varargin{1};
    YF = Y1 -1 + ceil(T/Frequency);
elseif nargin == 4
    Y1 = varargin{1};
    YF = varargin{2};
    T = (YF-Y1+1)*Frequency;
else
    error('SeasonalDummies debe tener entre 2 y 4 argumentos');
end
%----------------------------------------------------


%Y1 = 1990;
%YF = Y1 -1 + ceil(T/Frequency);
yr = repmat((Y1:YF),Frequency,1);
mo = repmat((1:Frequency)',1,ceil(T/Frequency));
fe = datestr(datenum(yr(:),mo(:),1));
FE = datevec(fe);
FE = FE(:,1:2);

SeasDUM = NaN(size(FE,1),Frequency-1);

for s = 1:Frequency-1
    SeasDUM(:,s) = double(FE(:,2)==s) - double(FE(:,2)==Frequency);
end


SeasDUM = SeasDUM(1:T,:);
FE=FE(1:T,:);

%PRUEBA:
%SeasDUM(SeasDUM==0)= -1;
%SeasDUM = SeasDUM/Frequency;
SeasDUM(SeasDUM==-1)=0;
SeasDUM = SeasDUM-1/Frequency;



end %function
