%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Author: GUILLERMO CARLOMAGNO: March 2021
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [YparcMat, Wparc, Yparc, Yparc4Incid, D1YparcIncid] = computePartial_CPI(YMat_orig, W_orig, idxKepp, varargin) 

checkSize = sum(size(YMat_orig)==size(W_orig));
if checkSize~=2
    error('YMat_orig and W_orig must have the same dimensions');
end

if isempty(varargin)
    DataIsDiff=0;
else
    DataIsDiff = varargin{1};
end

T = size(YMat_orig,1);

YparcMat = YMat_orig;
YparcMat(:, idxKepp==0) = [];
Wparc = W_orig; 
Wparc(:,idxKepp==0)=[];

Nnew=size(Wparc,2);
Wparc = Wparc./repmat(sum(Wparc,2),1,Nnew);

WparcIncid = W_orig;
WparcIncid(:,idxKepp==0)=[];


if DataIsDiff ==0
    D1yParc = crecPrc(YparcMat, 1);
    D1yParc(Wparc==0)=0;
    D1yParc(isnan(D1yParc))=0; D1yParc(~isfinite(D1yParc))=0;
    
    D1Yparc = sum(D1yParc.*Wparc,2);
    D1YparcIncid = sum(D1yParc.*WparcIncid,2);
    Yparc = nan(T,1); Yparc(1)=100;
    Yparc4Incid = Yparc;
    for t=2:T
        Yparc(t) = Yparc(t-1)*(1+D1Yparc(t));      
        Yparc4Incid(t) = Yparc4Incid(t-1)*(1+D1YparcIncid(t));      
    end
    
else
   
    YparcMat(Wparc==0)=0;
    YparcMat(isnan(YparcMat))=0; YparcMat(~isfinite(YparcMat))=0;     
    Yparc = sum(YparcMat.*Wparc,2);
    Yparc4Incid = sum(YparcMat.*WparcIncid,2);
    
end



end%function 