%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GUILLERMO CARLOMAGNO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [yTrim, idxOptTrim, idxFin, LowOptTrim, OptUpTrim, optW, All_opStatTrim, AllTrimed_stats] = ...
                    evaluateTrimed_1(ALP, useAllTrimed, IPC, useBias, tolerance, SIZE_W_var, symtericTrim, idx0_samplOpt, idxF_samplOpt)

D1IPC = crecPrc(IPC, 1);

global ff; global ffBias;  global useRoot;

qAlp = length(ALP);

Permut = [];
if (SIZE_W_var==0)
    if symtericTrim==1
        Permut =[(1:qAlp)', (1:qAlp)'];
    else
        Permut = permn(1:qAlp,2); 
        Permut = sortrows(Permut,[1 2]);        
    end
    allALP = [ALP(Permut(:,1))', ALP(Permut(:,2))'];
else    
    for i=1:length(SIZE_W_var)
        w = SIZE_W_var(i);
        Permut = [Permut; [ones(qAlp,1)*w, ALP']];        
    end
    allALP = repmat(ALP', length(SIZE_W_var),1);
end
qTrimed = size(useAllTrimed,2);

D1_AllTrim = crecPrc(useAllTrimed, 1);

All_opStatTrim = nan(qTrimed,1);
AllTrimed_stats = nan(qTrimed, 4);
all_sig_bias =  nan(qTrimed, 3);
sumAlp_Trim =  nan(qTrimed, 1);
for i=1:qTrimed
    sumAlp_Trim(i) = sum(allALP(i,:));
    D1y = D1_AllTrim(:,i);
    [rho, sig_y, stat_bias] = callStats(D1y, idx0_samplOpt, idxF_samplOpt, useRoot, ff);   
    if useBias==0
         stat_bias=nanmean(D1IPC(idx0_samplOpt:idxF_samplOpt))*ff*ffBias;
    end    
    all_sig_bias(i,:) = [sig_y, stat_bias, rho];    
end

allStats = [all_sig_bias(:,1), all_sig_bias(:,3), all_sig_bias(:,2), zeros(qTrimed,2)];
benchMarks = min(allStats);
benchMarks(2) = max(allStats(:,2));
benchMarks(3) = 3;
pondFeat = [ones(3,1); 0; 0];
wMat = diag(pondFeat);

for i=1:qTrimed                         
    opt_stat = optStat_1Full(all_sig_bias(i,3), all_sig_bias(i,1), all_sig_bias(i,2), 0, 0, wMat, benchMarks);
    All_opStatTrim(i) = opt_stat;
    AllTrimed_stats(i,:) = [all_sig_bias(i,3), all_sig_bias(i, [1,2]), sumAlp_Trim(i)];
end

[~, idxOptTrim] = min(All_opStatTrim);
RelStat = All_opStatTrim/All_opStatTrim(idxOptTrim);
idx_Equal = find(double(RelStat<(1+tolerance)) .* double(RelStat>1) );
if (isempty(idx_Equal))
    idx_Equal = idxOptTrim;
end
%---------------------------------------------

if SIZE_W_var ==0 
    optW = [];
    allLowTrim = ALP(Permut(idx_Equal, 1));
    allUpTrim =  ALP(Permut(idx_Equal, 2));
    sumAll = allLowTrim + allUpTrim;
    [~, idxMin] = min(sumAll);
    idxFin = idx_Equal(idxMin);
    
    LowOptTrim = ALP(Permut(idxFin, 1)); 
    OptUpTrim = ALP(Permut(idxFin, 2));
else
    LowOptTrim = [];
    allUpTrim =  Permut(idx_Equal, 2);
    [~, idxMin] = min(allUpTrim);
    idxFin = idx_Equal(idxMin);    
    optW = Permut(idxFin, 1);
    OptUpTrim = Permut(idxFin, 2);
end

yTrim = useAllTrimed(:, idxFin);

end% function