%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%GUILLERMO CARLOMAGNO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function  [r_gamm0, r_gamm1, MaxRoot, optLag, phi1, sig] = persist_withSel(y, maxLag, selLags, critSel, SeasDUM)
        
if selLags==1
    optLag = LagSelectionAR(y ,(1:maxLag), critSel);  
    L = optLag;
else
    L = maxLag;
end
optLag=L;

if ~isempty(SeasDUM)
    useSeas = SeasDUM(L+1:end,:);
else
    useSeas =[];
end
    

whichstats = {'beta', 'r'};
yLag = lagmatrix(y, (1:L));
yLag = yLag(L+1:end, :);
y = y(L+1:end);

X = [yLag, useSeas];
stats = regstats(y,X,'linear',whichstats);

coef = stats.beta;
e = stats.r;
sig = sqrt(nanmean(e.*e));

phis = coef(L+1:-1:2);
phi1=phis(end);

Allroot = abs(roots([-phis; 1]));
MaxRoot = 1/min(Allroot);
%--------------------------------

y1 = lagmatrix(y,1);
mu = nanmean(y);
gamm1 = nanmean((y-mu).*(y1-mu));
gamm0 = nanmean((y-mu).*(y-mu));
r_gamm1 = (gamm1);
r_gamm0 = (gamm0);


end