%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%GUILLERMO CARLOMAGNO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [y_core, AllDrop, inflTrimed] = trimed_var_w(Y, val0, W_implD1, SIZE_W, ALP_trim, useDiff)
     
    %NOTE: If useDiff is not 12, Y should be seasonal adjusted

    [T,N] = size(Y);
    PI = crecPrc(Y, useDiff);
    PI1 = crecPrc(Y, 1);
   
    %-------------Controls---------
        if( ~isscalar(ALP_trim) && (length(ALP_trim)~=T || length(SIZE_W)~=T) )
            error('Y_sa and alp_low must have the same length')
        end
    %------------------------------    
    
    if isscalar(ALP_trim)
        ALP_trim = ones(T,1)*ALP_trim;
        SIZE_W = ones(T,1)*SIZE_W;
    end    
    
    maxS = max(SIZE_W);    
    inflTrimed = nan(T,1);
    AllDrop = nan(N,T);
    idxAll = (1:N);
    for t = max(useDiff+1, maxS):T
        alp_trim = ALP_trim(t);
        sizeW = SIZE_W(t);
        
        if(sizeW>1)
            sig = nanstd( PI(t-sizeW+1:t, :)); 
        else
            sig = abs(PI(t,:) - nanmean(PI(t-min(12,t)+1:t,:)));
        end
        pi = PI(t,:);
        
%         t
        idx_sigNan = find(isnan(sig));
        idx_W0 = find(W_implD1(t,:)==0); idx_Wnan = find(isnan(W_implD1(t,:)));
        idxDrop = unique([find(isnan(pi)), idx_W0, idx_Wnan, idx_sigNan]);
%         idxDrop
        
        piC = pi; piC(idxDrop)=[];  
%         pi
%         piC
        pi1C = PI1(t,:); pi1C(idxDrop)=[];
        idxAllC = idxAll; idxAllC(idxDrop)=[];
        wC =  W_implD1(t, :); wC(idxDrop) = [];
        sigC = sig; sigC(idxDrop)=[]; 
     
        Ncorr = N - length(idxDrop);
        [~, idxSort] = sort(sigC);
        idxAllSort = idxAllC(idxSort);
        
        %----------------------------
         w_sort = wC(idxSort);
         wCum = cumsum(w_sort');
         wcum_Up = wCum(wCum<=1-alp_trim); qUp = Ncorr-length(wcum_Up)+1;
        %------------------------------
        
        dropUp = idxSort(end-qUp+1: end);
        keep = setxor(idxSort, dropUp);
        useWprel = wC(keep); 
        useW = useWprel/sum(useWprel);
        %use_pi = pi1C(keep);   
        use_pi = piC(keep);   
        inflTrimed(t) = use_pi*useW';    
        
        AllDrop(1:qUp,t) = idxAllSort(end-qUp+1: end); 
    end    
    
    y_core = nan(T,1); 
    %y_core(max(2, maxS)-1) = val0;
    y_core(max(useDiff, maxS-1)) = val0;
    for t=max(useDiff+1, maxS):T
        y_core(t) = y_core(t-useDiff)*(1+inflTrimed(t));
    end
        
end %function