%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%GUILLERMO CARLOMAGNO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [y_core, lastW] = varWeight(Y, val0, W_implD1, sizeW, useDiff)

   %NOTE: If useDiff is not 12, Y should be seasonal adjusted

    T = size(Y,1);
    PI = crecPrc(Y, useDiff);
    PI1 = crecPrc(Y, 1);
     
    inflAdjVar = nan(T,1);
    for t = useDiff+sizeW:T %max(sizeW, useDiff+1):T
        
        sig = nanstd( PI(t-sizeW+1:t, :)); 
        
        pi = PI(t,:);
        idx_sigNan = unique([find(isnan(sig)), find(sig==0)] );
        idx_W0 = find(W_implD1(t,:)==0); idx_Wnan = find(isnan(W_implD1(t,:)));
        idxDrop = unique([find(isnan(pi)), idx_W0, idx_Wnan, idx_sigNan]);
        %piC = pi; piC(idxDrop)=[];
        pi1C = PI1(t,:); pi1C(idxDrop)=[];
        
        wC =  W_implD1(t, :); wC(idxDrop) = [];        
        sigC = sig; sigC(idxDrop)=[];
     
        useWPrel = wC./sigC;
        useW = useWPrel/sum(useWPrel);
        
        inflAdjVar(t) = sum(pi1C.*useW,2);      
        
        wfull = W_implD1(t, :)./sig;
    end    
    lastW = wfull;
    
    y_core = nan(T,1); 
    %y_core(max(sizeW-1, useDiff)) = val0;
    y_core(useDiff+sizeW-1) = val0;
    for t=useDiff+sizeW:T %max(sizeW, useDiff+1):T
        y_core(t) = y_core(t-1)*(1+inflAdjVar(t));
    end
    
    
end %function
    