%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%GUILLERMO CARLOMAGNO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;

%% Routes 
workRoute ='C:\Users\gcarlomagno\OneDrive - Banco Central de Chile\Escritorio\GC_13Mar_20\CanastaIPC\CoreInflation_separata\';
FolderData = [workRoute, 'data\'];
allFolders = genpath([workRoute, 'functions\']);
addpath(allFolders);
cd (workRoute)

%% Load Parameters
PARAMETERS_and_DATA_sp

%% Construct series and weigths
[Y_sa, useY_sa, Yfin, PONDImplD1, PONDImplD12, Wmat, useFE] = IMPORT_DATA_sp(useYearF,useMonth0, useMonthF, FolderData );
[T,N] = size(Yfin);

useYear0_Opt = 2003; useMonth0_Opt = 1;
idx0_samplOpt = yearMonth2_idx(useFE, useYear0_Opt, useMonth0_Opt);
useYearF_Opt = useYearF ; useMonthF_Opt = useMonthF;
idxF_samplOpt = yearMonth2_idx(useFE, useYearF_Opt, useMonthF_Opt);
[W_implD1, W_implD12, useYfin, D12Yfin, useY_saFullsmp, D1Yfin, D1Yfin_sa] = PrepareData_sp(PONDImplD1, PONDImplD12, Yfin, Y_sa);

[~, ~, IPCconstr_sa] = computePartial_CPI(useY_saFullsmp, W_implD1, (1:N));
D1IPC  =  sum(W_implD1.*D1Yfin,2);
D1IPC_sa  =  sum(W_implD1.*D1Yfin_sa,2);
Y4Trim = useY_sa;

%% Compute trimmed measures (mean mean and variance)
ALP = (0.05:sizeStepAlp:0.45);
ALP_var = (0.1:sizeStepAlp:0.90);

[AllTrimed, AllDropUp, AllDropLow, AllTrimedVar, All_adjVar, AllDropVar] =...
            call_Trimed(Y4Trim, ALP, ALP_var, SIZE_W_var, symtericTrim, W_implD1, useDiffTrim);

%% Evaluate Trimmed
yTrim=cell(2,1); yTrim_var = cell(2,1);
OptLowTrim = cell(2,1); OptUpTrim = cell(2,1);
OptUpTrim_var = cell(2,1);
for opt_bias = 0:1
    i=opt_bias+1;
     [yTrim{i}, idxOptTrim{i}, idxFinTrim{i}, OptLowTrim{i}, OptUpTrim{i}, ~, All_opStatTrim{i}, AllTrimed_stats{i}] = ...
        evaluateTrimed_1(ALP, AllTrimed, IPCconstr_sa(1:end), opt_bias, toleranceMP, 0, symtericTrim, idx0_samplOpt, idxF_samplOpt);
    
    [yTrim_var{i}, idxOptTrim_var{i}, idxFinTrim_var{i}, ~, OptUpTrim_var{i}, optW{i}, All_opStatTrim_var{i}, AllTrimed_stats_var{i}] =...
        evaluateTrimed_1(ALP_var, AllTrimedVar, IPCconstr_sa(1:end), opt_bias, toleranceMPV, SIZE_W_var, symtericTrim, idx0_samplOpt, idxF_samplOpt);    
    
    [y_adjVar{i}, ~, ~, ~, ~, optWadj{i}, All_opStatTrim_adj{i}, AllTrimed_stats_adj{i}] =...
        evaluateTrimed_1(0, All_adjVar, IPCconstr_sa(1:end), opt_bias, toleranceMPV, SIZE_W_var, symtericTrim, idx0_samplOpt, idxF_samplOpt);                
end


%% Computye DFM
[F_hat_c, F_pc_c] = constructDFM(Y_sa, sers2DropDFM, D1IPC_sa);
                                
%% save resutls
if saveFiles==1
   namesSersSave = {'prom', 'max', 'min'};
   nameFileSave = ['SummaryCores', num2str(useYearF)]; 
   [meanC, maxC, minC] = computeMeanIndic([yTrim{2}, F_hat_c, y_adjVar{2}, yTrim_var{2}], 1);
   D12Save = crecPrc([meanC, maxC, minC],12);
   xlswrite([routeSave, nameFileSave], D12Save, 'hoja1','B2');
   xlswrite([routeSave, nameFileSave], namesSersSave, 'hoja1','B1');
end

